Attribute VB_Name = "Crypt"
'
' Copyright (C) 2000-2001 SAP AG
'


' Module name
Const MODULE_NAME = "SQLStudioCt"

'
' Crypt & DeCrypt
'
Option Explicit


Const MAXCRYPT = 6

Type PW_CLEAR_TYPE
  s As String * 18
End Type

Type PW_CRYPT_TYPE
  s As String * 24
End Type

Type CRYPT_TYPE
  l(1 To MAXCRYPT) As Long
End Type

Declare Sub CopyMem Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
                            pDest As Any, _
                            pSource As Any, _
                            ByVal ByteLen As Long)


'Extrem Crypt
Sub CryptPW(typPwClear As PW_CLEAR_TYPE, typPwCrypt As PW_CRYPT_TYPE)
  On Error GoTo OnError_Msg_CryptPW
    
  Const FUNCTION_NAME = "CryptPW"
    
  Dim i As Integer
  Dim vp1 As Long
  Dim vp2 As Long
  Dim vp3 As Long
  Dim lleft As Long
  Dim rright As Long
  Dim typCrypt As CRYPT_TYPE
 
  vp1 = 2
  vp2 = 521
  vp3 = 133379
  
  For i = 1 To MAXCRYPT
      
      If Len(Mid$(typPwClear.s, 3 * i - 2, 1)) < 1 Then Exit Sub
      If Len(Mid$(typPwClear.s, 3 * i - 1, 1)) < 1 Then Exit Sub
      If Len(Mid$(typPwClear.s, 3 * i, 1)) < 1 Then Exit Sub
      
      typCrypt.l(i) = Asc(Mid$(typPwClear.s, 3 * i - 2, 1)) * vp3 + Asc(Mid$(typPwClear.s, 3 * i - 1, 1)) * vp2 + Asc(Mid$(typPwClear.s, 3 * i, 1)) * vp1
  Next

  For i = 1 To MAXCRYPT
    If i > 1 Then
       lleft = typCrypt.l(i - 1)
    Else
       lleft = vp3
    End If
    typCrypt.l(i) = typCrypt.l(i) + ((lleft Mod 61) * (vp3 * 126 - 1))
  Next

  For i = MAXCRYPT To 1 Step -1
    If i < MAXCRYPT - 1 Then
       rright = typCrypt.l(i + 1)
    Else
       rright = vp2
    End If
    typCrypt.l(i) = typCrypt.l(i) + ((rright Mod 61) * (vp3 * 128 - 1))
  Next

  For i = 1 To MAXCRYPT
    If typCrypt.l(i) Mod 2 <> 0 Then typCrypt.l(i) = -typCrypt.l(i)
  Next

  'LSet typPwCrypt = typCrypt
  'Replace LSet to be prepared for VB.NET, LSet is not supported in VB.NET
  CopyMem typPwCrypt, typCrypt, Len(typPwCrypt)
  

  Exit Sub
    
OnError_Msg_CryptPW:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Sub CryptToString(typPwCrypt As PW_CRYPT_TYPE, s As String)
    On Error GoTo OnError_Msg_CryptToString
    
    Const FUNCTION_NAME = "CryptToString"
    
    Dim i As Integer
    Dim typCrypt As CRYPT_TYPE
    
    'LSet typCrypt = typPwCrypt
    'Replace LSet to be prepared for VB.NET, LSet is not supported in VB.NET
    CopyMem typCrypt, typPwCrypt, Len(typCrypt)
    
    s = ""
    For i = 1 To MAXCRYPT
       s = s + Format$(Hex$(typCrypt.l(i)), "@@@@@@@@")
    Next
    For i = 1 To 24
       If Mid$(s, i, 1) = " " Then Mid$(s, i) = "0"
    Next
        
    
    Exit Sub
    
OnError_Msg_CryptToString:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Sub DeCryptPW(typPwCrypt As PW_CRYPT_TYPE, typPwClear As PW_CLEAR_TYPE)
    On Error GoTo OnError_Msg_DeCryptPW
        
    Const FUNCTION_NAME = "DeCryptPW"
    
      Dim i As Integer
      Dim vp1 As Long
      Dim vp2 As Long
      Dim vp3 As Long
      Dim lleft As Long
      Dim rright As Long
      Dim exp1 As Long
      Dim exp2 As Long
      Dim exp3 As Long
      Dim typCrypt As CRYPT_TYPE
      Dim pw_notnull As Integer
    
      vp1 = 2
      vp2 = 521
      vp3 = 133379
    
      'LSet typCrypt = typPwCrypt
      'Replace LSet to be prepared for VB.NET, LSet is not supported in VB.NET
      CopyMem typCrypt, typPwCrypt, Len(typCrypt)
      
      For i = 1 To MAXCRYPT
        pw_notnull = ((typCrypt.l(i) <> 0) Or pw_notnull)
      Next
    
      If Not pw_notnull Then
        typPwClear.s = Space$(18)
      Else
        For i = 1 To MAXCRYPT
          If typCrypt.l(i) Mod 2 <> 0 Then typCrypt.l(i) = -typCrypt.l(i)
        Next
    
        For i = 1 To MAXCRYPT
          If i < MAXCRYPT - 1 Then
            rright = typCrypt.l(i + 1)
          Else
            rright = vp2
          End If
          typCrypt.l(i) = typCrypt.l(i) - ((rright Mod 61) * (vp3 * 128 - 1))
        Next
    
        For i = MAXCRYPT To 1 Step -1
          If i > 1 Then
            lleft = typCrypt.l(i - 1)
          Else
            lleft = vp3
          End If
          typCrypt.l(i) = typCrypt.l(i) - ((lleft Mod 61) * (vp3 * 126 - 1))
        Next
    
        For i = 1 To MAXCRYPT
          exp3 = typCrypt.l(i)
          exp1 = exp3 \ vp3
          exp2 = exp3 Mod vp3
          Mid$(typPwClear.s, 3 * i - 2) = Chr$(exp1)
          exp3 = exp2
          exp1 = exp3 \ vp2
          exp2 = exp3 Mod vp2
          Mid$(typPwClear.s, 3 * i - 1) = Chr$(exp1)
          exp3 = exp2
          exp1 = exp3 \ vp1
          exp2 = exp3 Mod vp1
          Mid$(typPwClear.s, 3 * i) = Chr$(exp1)
        Next
      End If
        
    
      Exit Sub
  
OnError_Msg_DeCryptPW:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Sub StringToCrypt(s As String, typPwCrypt As PW_CRYPT_TYPE)
    On Error GoTo OnError_Msg_StringToCrypt
    
    Const FUNCTION_NAME = "StringToCrypt"
    
    Dim i As Integer
    Dim typCrypt As CRYPT_TYPE
    For i = 1 To MAXCRYPT
      typCrypt.l(i) = Val("&H" + Mid$(s, (i - 1) * 8 + 1, 8))
    Next
    
    'LSet typPwCrypt = typCrypt
    'Replace LSet to be prepared for VB.NET, LSet is not supported in VB.NET
    CopyMem typPwCrypt, typCrypt, Len(typPwCrypt)
    

    Exit Sub
 
OnError_Msg_StringToCrypt:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

